%
% Definitions
%

%
% Name of this paper
%
\newcommand\papername{%
\iftechreport
   technical report%
\else
   abstract%
\fi}

%
% Footnotes don't use fancy fonts
%
\let\xxxref=\ref
\renewcommand\ref[1]{{%
   \def\subsecfnt{}%
   \xxxref{#1}}}

%
% Technical report number
%
\def\trnum{caltechCSTR 2002.007}
   
%
% Comments
%
\newdimen\columnwidth
\iftechreport
   \setlength\columnwidth{\textwidth}
\else
   \setlength\columnwidth{3in}
\fi
\newdimen\commentwidth
\setlength{\commentwidth}{\columnwidth}
\newcommand\comment[1]{%
    \begin{center}
      \advance\commentwidth by -0.5in
      \fbox{\begin{minipage}{\commentwidth}
            \sf #1
            \end{minipage}}
    \end{center}}
\newcommand\nocomment[1]{}

%
% User-specific macros
%
\newif\ifjustins
\newcommand\jyh{%
   \newpage
   \section{JYH}}

%
% Some generic names for expressions, values, etc.
% You can override these if you want a rule to print
% differently.
%
\newcommand\varorig{v}
\newcommand\labelorig{l}
\newcommand\atomorig{a}
\newcommand\heaporig{h}
\newcommand\exporig{e}
\newcommand\typeorig{t}
\newcommand\alttypeorig{u}
\newcommand\kindorig{k}
\newcommand\skindorig{\kindorig_s}
\newcommand\genvorig{\Gamma}
\newcommand\cenvorig{{\cal C}}
\newcommand\funorig{a_f}
\newcommand\tailoporig{\iftechreport \ms{tailop} \else \ms{spec} \fi}
\newcommand\allocoporig{\ms{alloc}}
\newcommand\arrayorig{\atomorig}
\newcommand\offsetorig{\atomorig}
\newcommand\sizeorig{\atomorig}
\newcommand\frameorig{\ms{frame}}
\newcommand\recordorig{r}
\newcommand\tyframeorig{\ms{Frame}}
\newcommand\tyrecordorig{R}
\newcommand\checkpointorig{C}
\newcommand\tyvarorig{\ms{tv}}
\newcommand\conclorig{J}

\newcommand\varname{\varorig}
\newcommand\labelname{\labelorig}
\newcommand\atomname{\atomorig}
\newcommand\atomnameone{\atomname_1}
\newcommand\atomnametwo{\atomname_2}
\newcommand\heapname{\heaporig}
\newcommand\expname{\exporig}
\newcommand\typename{\typeorig}
\newcommand\alttypename{\alttypeorig}
\newcommand\kindname{\kindorig}
\newcommand\skindname{\skindorig}
\newcommand\genvname{\genvorig}
\newcommand\cenvname{\cenvorig}
\newcommand\genvtypename{\genvname}
\newcommand\funname{\funorig}
\newcommand\tailopname{\tailoporig}
\newcommand\allocopname{\allocoporig}
\newcommand\arrayname{\arrayorig}
\newcommand\offsetname{\indexorig}
\newcommand\sizename{\sizeorig}
\newcommand\framename{\frameorig}
\newcommand\recordname{\recordorig}
\newcommand\tyframename{\tyframeorig}
\newcommand\tyrecordname{\tyrecordorig}
\newcommand\checkpointname{\checkpointorig}
\newcommand\tyvarname{\tyvarorig}
\newcommand\conclname{\conclorig}

\newcommand\setvarname[1]{\def\varname{#1}}
\newcommand\setlabelname[1]{\def\labelname{#1}}
\newcommand\setatomname[1]{\def\atomname{#1}}
\newcommand\setatomnameone[1]{\def\atomnameone{#1}}
\newcommand\setatomnametwo[1]{\def\atomnametwo{#1}}
\newcommand\setheapname[1]{\def\heapname{#1}}
\newcommand\setexpname[1]{\def\expname{#1}}
\newcommand\settypename[1]{\def\typename{#1}}
\newcommand\setalttypename[1]{\def\alttypename{#1}}
\newcommand\setkindname[1]{\def\kindname{#1}}
\newcommand\setskindname[1]{\def\skindname{#1}}
\newcommand\setgenvname[1]{\def\genvname{#1}}
\newcommand\setcenvname[1]{\def\cenvname{#1}}
\newcommand\setgenvtypename[1]{\def\genvtypename{#1}}
\newcommand\setfunname[1]{\def\funname{#1}}
\newcommand\settailopname[1]{\def\tailopname{#1}}
\newcommand\setallocopname[1]{\def\allocopname{#1}}
\newcommand\setarrayname[1]{\def\arrayname{#1}}
\newcommand\setoffsetname[1]{\def\offsetname{#1}}
\newcommand\setsizename[1]{\def\sizename{#1}}
\newcommand\setframename[1]{\def\framename{#1}}
\newcommand\setrecordname[1]{\def\recordname{r}}
\newcommand\settyframename[1]{\def\tyframename{#1}}
\newcommand\settyrecordname[1]{\def\tyrecordname{#1}}
\newcommand\setcheckpointname[1]{\def\checkpointname{#1}}
\newcommand\settyvarname[1]{\def\tyvarname{#1}}
\newcommand\setconclname[1]{\def\conclname{#1}}

%
% Hyperlinks, targets, and references
%
\newcommand\deflabel[2]{\hypertarget{def:#1}{\emph{#2}}}
\newcommand\defref[2]{\hyperlink{def:#1}{#2}}

%
% Theorem environments
%
\newtheorem{definition}{Definition}[section]
\newtheorem{property}{Property}[section]
\newtheorem{propose}{Proposition}[section]
\newtheorem{theorem}{Theorem}[section]
\newtheorem{lemma}{Lemma}[section]
\newtheorem{corollary}{Corollary}[section]

%\newtheorem{example}{Example}[section]

\newcommand{\thmtitle}[1]{{\sc #1}}

%
% Paper already has {proof} environment.
%
\iftechreport
   \newenvironment{proof}{}{\hfill$\Box$}
\fi
\newenvironment{block}{}{}
\newenvironment{proofcase}[1]{\begin{description}\item[#1]}
   {\hfill$\diamond$\end{description}}
\newenvironment{itemcase}[1]
   {\iftechreport\begin{description}\item[#1]
    \else\noindent{\bf #1}
    \fi}
   {\iftechreport\end{description}
    \else
    \fi}

%
% Code areas
%
\newcommand\tab{\hskip2em}
\newenvironment{code}{%
\begin{tabbing}
\tab\=\tab\=\tab\=\tab\=\kill}
{\end{tabbing}}

%
% Formatting: place the first argument as a hypertarget on the right
% margin
%
%% \newcommand\mathtarget[2]{%
%%    \begin{center}
%%    \hbox to \textwidth{\hfil $#2$ \hfil \hypertarget{mathtarget:#1}{\sc #1}}
%%    \end{center}}
\newcommand\mathtarget[2]{%
   \par
   \mbox{\hbox to \columnwidth{\hfil $#2$ \hfil \hypertarget{mathtarget:#1}{\sc #1}}}
   \par}
                     

\newcommand\refmath[1]{\hbox{\hyperlink{mathtarget:#1}{\sc #1}}}

%% \newcommand\mathright[2]{%
%%    \begin{center}
%%    \hbox to \textwidth{\hfil $#2$ \hfil {\sc #1}}
%%    \end{center}}
\newcommand\mathright[2]{%
   \par%
   \phantom{}{\centering \hbox to \textwidth{\hfil $#2$ \hfil {\sc #1}}}%
   \par%
}

%
% Code environment
%
\newcommand\mb[1]{{\bf #1}}
\newcommand\ms[1]{{\it #1}}
\newcommand\mt[1]{{\sf #1}}
\renewcommand\tt[1]{\texttt{#1}}
\newcommand\semleft{[\![}
\newcommand\semright{]\!]}
\newcommand\vbar{\mathrel{|}}
\newcommand\istype[1]{#1\ \ms{type}}

%
% Abbreviations
%
\newcommand{\U}{{\mathcal{U}}}
\newcommand{\B}{{\mathcal{B}}}
\newcommand{\G}{{\mathcal{G}}}
\newcommand{\D}{{\mathcal{D}}}
\newcommand{\F}{{\mathcal{F}}}
\newcommand{\A}{{\mathcal{A}}}
\newcommand{\C}{{\mathcal{C}}}
\newcommand{\Own}{{\mathcal{O}}}
\newcommand{\R}{{\mathcal{R}}}
\newcommand{\I}{{\mathcal{I}}}
\newcommand{\E}{{\mathcal{E}}}
\newcommand{\sta}{{\mathcal{S}}}
\newcommand{\reals}{{\mathbb{R}}}
\newcommand{\complexes}{{\mathbb{C}}}
\newcommand{\ints}{{\mathbb{Z}}}
\newcommand{\nums}{{\mathbb{N}}}
\newcommand{\nat}{{\mathbb{N}}}
\newcommand{\preset}[1]{\; ^\bullet {#1}}
\newcommand{\postset}[1]{{#1}^\bullet}
\newcommand{\goesto}[1]{\rightarrow^{#1}}
\newcommand{\grad}{\nabla}
\newcommand{\sle}{\sqsubseteq}
\newcommand{\xbstar}{x_b^*}
\newcommand{\ksync}{k_s}
\newcommand{\eref}[1]{(\ref{#1})}
\newcommand{\torus}{{\mathbb{T}^2}}
\newcommand{\rf}{\mathcal{R}}
\newcommand{\ratio}[2]{#1\!:\!#2}
\newcommand{\md}[1]{\;(\mathrm{mod}\;#1)}
\newcommand{\vvec}[2]{ \left ( \begin{array}{c} #1 \\ #2 \end{array} \right ) }
\newcommand{\dunion}{\amalg}
\newcommand{\bigoh}[1]{{\mathrm O}(#1)}
\newcommand{\assign}{\leftarrow}
\newcommand{\clause}[2]{(#1,#2)}
\newcommand{\refby}{\succeq}
\newcommand{\into}{\rightarrow}
\newcommand{\setbuild}[2]{\{#1\;|\;#2\}}
\newcommand{\enum}[1]{\{#1\}}
\newcommand{\defeq}{\triangleq}
\newcommand{\sleadsto}[1]{\;^{\underrightarrow{\;#1\;}}\;}
\newcommand{\eps}{\varepsilon}
\newcommand{\perms}{\mathit{Perm}}
\newcommand{\undef}{\bot}
\newcommand{\partinto}{\multimap \! \rightarrow}
\newcommand{\parcomp}{||}
\newcommand{\immset}{\mathit{Imm}}
\newcommand{\defset}{\mathit{Def}}
\newcommand{\leadstonew}{\rightsquigarrow}

%
% JDS macros
%
\newcommand\mkset[1]{\{#1\}}
\newcommand\mrm[1]{\mathrm{#1}}
\newcommand\msc[1]{\hbox{\sc #1}}
\newcommand\dosplit[1]{\begin{split}#1\end{split}}
\newcommand\figref[2]{\hyperlink{#1}{#2}}

% BTW, we will want to make these real figures when we are
% ready to prepare a final draft.  The reason they are *not*
% figures now is because there's no text to flow around the
% figures, and latex kept rearranging the paper in really
% funky ways so the syntax tables would be on, say, page 7...

\newcommand\makefigure[3]{\begin{figure}[!ht]#3\caption{#2}\label{#1}\end{figure}}
\newcommand\makefiguretwocolumn[3]{\begin{figure*}[!ht]#3\caption{#2}\label{#1}\end{figure*}}
%\newcommand\makefigure[3]{\label{#1}#3\begin{center}\hypertarget{#1}{#2}\end{center}}

% To render without figures, uncomment these guys.
%\newcommand\makefigure[3]{}
%\newcommand\makefiguretwocolumn[3]{}

\newcommand\xvector[1]{{\left< #1 \right>}}
\newcommand\dom[1]{\ms{dom}(#1)}
\newcommand\freevars[1]{\ms{FV}(#1)}

\def\ifEmpty#1#2#3{\def\@tempa{}\def\@tempb{#1}%
   \ifx \@tempa \@tempb #2\else #3\fi }

%
% Misc. constructs
%
\newcommand\hint{\diamond}
\newcommand\zstring{\ms{string}}
\newcommand\zfloat{\ms{float}}
\newcommand\pre{\ms{pre}}
\newcommand\fpre{\ms{fpre}}
\newcommand\sign{\ms{sign}}
\newcommand\signed{\mb{signed}}
\newcommand\unsigned{\mb{unsigned}}
\newcommand\rawint{\ms{r}}
\newcommand\xset{\iftechreport \ms{set} \else s \fi}
\newcommand\rawintset{{\xset_\ms{R}}}
\newcommand\tyvar{\tyvarname}
\newcommand\xlabel{\labelname}
\newcommand\debuglabel{\hint}
\newcommand\unop{\ms{unop}}
\newcommand\binop{\ms{binop}}
\newcommand\subop{\hint}
\newcommand\xop{\ms{op}}
\newcommand\normaltuple{\mb{normal}}
\newcommand\boxedtuple{\mb{box}}
\newcommand\maxenum{\ms{max\_enum}}
\newcommand\wordsize{\ms{word\_size}}
\newcommand\tagglobal{\mathop{\mb{global}}}

%
% Short forms.
%
\newcommand\tupleclass{\iftechreport \ms{tuple\_class} \else \ms{tc} \fi}
\newcommand\intset{{\xset_\ms{I}}}

%
% Frames
%
\newcommand\framelabel[1]{\ifEmpty{#1}{l}{l^\ms{#1}}}
\newcommand\xframe{\ms{frame}}
\newcommand\frameinfo{\ms{frameinfo}}
\newcommand\fieldinfo{\ms{fieldinfo}}
\newcommand\labels[1]{\mb{labels}(#1)}
\newcommand\lookup[3]{\mb{lookup}(#1,\xvector{#2,#3})}

%
% Unary operators
%
\newcommand\uminusop[1]{\sim\!\!-_{#1}}
\newcommand\unotop[1]{\mb{lnot}_{#1}}
\newcommand\ubitfieldop[4]{\mb{bitfield}_{#1, #2}^{#3, #4}}
\newcommand\uabsop[1]{\mb{abs}_{#1}}
\newcommand\usinop[1]{\mb{sin}_{#1}}
\newcommand\ucosop[1]{\mb{cos}_{#1}}
\newcommand\usqrtop[1]{\mb{sqrt}_{#1}}
\newcommand\ucoerceop[2]{(#1 \leftarrow #2)}
\newcommand\upointerop[1]{\mb{pointer}_{#1}}

%
% Binary operators
%
\newcommand\plusop[1]{+_{#1}}
\newcommand\minusop[1]{-_{#1}}
\newcommand\mulop[1]{*_{#1}}
\newcommand\divop[1]{/_{#1}}
\newcommand\remop[1]{\mb{rem}_{#1}}
\newcommand\lslop{\mb{lsl}}
\newcommand\lsrop{\mb{lsr}}
\newcommand\asrop{\mb{asr}}
\newcommand\slop[1]{\mb{sl}_{#1}}
\newcommand\srop[1]{\mb{sr}_{#1}}
\newcommand\andop[1]{\mb{and}_{#1}}
\newcommand\orop[1]{\mb{or}_{#1}}
\newcommand\xorop[1]{\mb{xor}_{#1}}
\newcommand\maxop[1]{\mb{max}_{#1}}
\newcommand\minop[1]{\mb{min}_{#1}}
\newcommand\atanop[1]{\mb{atan2}_{#1}}
\newcommand\eqop[1]{=_{#1}}
\newcommand\neqop[1]{\not=_{#1}}
\newcommand\ltop[1]{<_{#1}}
\newcommand\leop[1]{\leq_{#1}}
\newcommand\gtop[1]{>_{#1}}
\newcommand\geop[1]{\geq_{#1}}
\newcommand\cmpop[1]{\mb{cmp}_{#1}}
\newcommand\setbitfieldop[4]{\mb{set\_bitfield}_{#1, #2}^{#3, #4}}
\newcommand\plusptrop[3]{+^{#1}_{#2, #3}}

%
% Types
%
\newcommand\tyint{\mathbb{Z}_{31}}
\newcommand\tyenum[1]{\mb{enum}_{#1}}
\newcommand\tyvoid{\tyenum{0}}
\newcommand\tybool{\tyenum{2}}
\newcommand\tyrawint[2]{\mathbb{Z}_{#1}^{#2}}
\newcommand\tyfloat[1]{\reals_{#1}}
\newcommand\tyfun[2]{#1 \rightarrow #2}
\newcommand\tyunion[3]{\mb{union}(#1[#2], #3)}
\newcommand\tytuple[2]{\left< #2 \right>_{#1}}
\newcommand\tyarray[1]{#1\ \mb{array}}
\newcommand\tyrawdata{\mb{data}}
\newcommand\tyapply[2]{#1[#2]}
\newcommand\tyexists[2]{\exists #1. #2}
\newcommand\tyall[2]{\forall #1. #2}
\newcommand\typroject[2]{#1.#2}
\newcommand\tydef{\ms{tydef}}
\newcommand\tydefunion[2]{\Lambda #1 . #2}
\newcommand\tydeflambda[2]{\Lambda #1 . #2}
\newcommand\tydefframe[2]{\Lambda #1 . #2}
\newcommand\stydef{\tydef_s}

%
% Frames
%
\newcommand\tyframe[2]{\mb{frame}(#1[#2])}
\newcommand\tyframerecord[1]{\left\{ #1 \right\}}
\newcommand\tyrecord[1]{\left\{ #1 \right\}}

%
% Atom terms
%
%\newcommand\atomnil[1]{\mb{nil}(#1)}
\newcommand\atomrawint[3]{\mb{rawint}_{#2}^{#3}(#1)}
\newcommand\atomfloat[2]{\mb{float}_{#2}(#1)}
\newcommand\atomenum[2]{\mb{enum}_{#1}(#2)}
\newcommand\atomint[1]{\mb{int}(#1)}
\newcommand\atomconst[2]{\mb{const}(#1, #2)}
\newcommand\atomlabel[4]{\mb{label}(#1, #2, #3, #4)}
\newcommand\atomsizeof[2]{\mb{sizeof}(#1, #2)}
\newcommand\atomvar[1]{#1}
\newcommand\atomfun[1]{#1}
\newcommand\atomunop[2]{\mathop{#1} #2}
\newcommand\atombinop[3]{#2 \mathrel{#1} #3}

\newcommand\xtyapply{\iftechreport \mb{ty\_apply} \else \mb{apply} \fi}
\newcommand\xtypack{\iftechreport \mb{ty\_pack} \else \mb{pack} \fi}
\newcommand\xtyunpack{\iftechreport \mb{ty\_unpack} \else \mb{unpack} \fi}
\newcommand\atomtyapply[2]{\xtyapply(#1, #2)}
\newcommand\atomtypack[2]{\xtypack(#1, #2)}
\newcommand\atomtyunpack[1]{\xtyunpack(#1)}

%
% Let definitions
%
\newcommand\xcase{\ms{case}}
\newcommand\tailop{\tailopname}
\newcommand\xlet{\mathop{\mb{let}}}
\newcommand\xin{\mathrel{\mb{in}}}
\newcommand\xalloc{\mathop{\mb{alloc}}}
\newcommand\xspecial{\mathop{\mb{special}}}
\newcommand\xmatch{\mathop{\mb{match}}}
\newcommand\xwith{\mathrel{\mb{with}}}
\newcommand\xas{\mathrel{\mb{as}}}
\newcommand\xif{\mathop{\mb{if}}}
\newcommand\xthen{\mathrel{\mb{then}}}
\newcommand\xelse{\mathrel{\mb{else}}}

%
% Expressions
%
\newcommand\letanyhead[3]{\xlet #1\colon #2 = #3}
\newcommand\letanytail[1]{\xin #1}
\newcommand\letany[4]{\letanyhead{#1}{#2}{#3} \letanytail{#4}}
\newcommand\letatom[4]{\letany{#1}{#2}{#3}{#4}}
%\newcommand\letunop[5]{\letany{#1}{#2}{\mathop{#3} #4}{#5}}
%\newcommand\letbinop[6]{\letany{#1}{#2}{#4 \mathrel{#3} #5}{#6}}
\newcommand\letexthead[5]{\letanyhead{#1}{#2}{(\text{``$#3$''} : #4)(#5)}}
\newcommand\letexttail[1]{\letanytail{#1}}
\newcommand\letext[6]{\letexthead{#1}{#2}{#3}{#4}{#5} \letexttail{#6}}
\newcommand\tailcall[2]{#1(#2)}
\newcommand\specialcall[1]{\xspecial #1}
\newcommand\tyalloc[1]{\xalloc #1}
\newcommand\tyspecial[1]{\xspecial #1}
\newcommand\matchstmt[2]{\xmatch #1 \xwith #2}
\newcommand\matchcase[2]{#1 \mapsto #2}
\newcommand\letalloc[3]{\xlet #1 = #2 \xin #3}
\newcommand\setsubscript[5]{#1[#2]\colon #3 \leftarrow #4;\ #5}
\newcommand\letsubscript[5]{\letany{#1}{#2}{#3[#4]}{#5}}
\newcommand\setglobal[4]{\tagglobal #1\colon #2 \leftarrow #3;\ #4}
\newcommand\letglobal[4]{\letany{#1}{#2}{\tagglobal #3}{#4}}

%
% Allocation
%
\newcommand\allocop{\allocopname}
\newcommand\alloctuplenoty[2]{\tytuple{#1}{#2}}
\newcommand\allocunionnoty[3]{\tyunion{#1}{#2}{#3}}
\newcommand\allocarraynoty[2]{\mb{array}(#1, #2)}
\newcommand\allocmallocnoty[1]{\mb{malloc}(#1)}
\newcommand\alloctuple[3]{\tytuple{#1}{#3} : #2}
\newcommand\allocunion[4]{\tyunion{#2}{#3}{#4} : #1}
\newcommand\allocarray[3]{\mb{array}(#2, #3) : #1}
\newcommand\allocmalloc[2]{\mb{malloc}(#2) : #1}
\newcommand\allocframe[2]{\mb{frame}(#1[#2])}

%
% SpecialCall ops
%
\newcommand\xfun{\iftechreport \ms{fun} \else f \fi}
\newcommand\xconst{\iftechreport \ms{const} \else c \fi}
\newcommand\xlevel{\iftechreport \ms{level} \else l \fi}
\newcommand\tailsysmigrate[5]{\mb{migrate}\ [#1, #2, #3]\ #4(#5)}
\newcommand\tailatomic[3]{\mb{atomic}\ #1(#2, #3)}
\newcommand\tailatomicrollback[2]{\mb{rollback}\ [#1, #2]}
\newcommand\tailatomiccommit[3]{\mb{commit}\ [#1]\ #2(#3)}

%
% Definitions in the environment
%
\newcommand\vdef[2]{#1\colon #2}
\newcommand\hdef[3]{\vdef{#1}{#2} = #3}

%
% Vectors.
%
% Vectors are enclosed in a vector macro.
% The vector defines an environment, so that we don't
% have to specify default values in most cases.  Within a vector
% the \set* macros can be used for customization.
%
% \ovec: prints using the overline notation
% \svec: prints using ellipses
%
% Normally, you would use it like this:
%    \svec{e\subi}
%
%    Produces: e_1, ..., e_n
%
% If you never want to use overline, then redefine \ovec as \svec.
%
% Since bounds are often important, the \cvec{e\subi}{xxx}{yyy}
% sets the bounds to get:
%    e_xxx, ..., e_yyy
%
\def\xxxsep{, \ldots,}
\def\xxxdefaultindex{i}
\def\xxxindex{\xxxdefaultindex}
\def\xxxlower{1}
\def\xxxupper{n}
\def\xxxleft{}
\def\xxxright{}

\newcommand\zvector[1]{{#1}}
\newcommand\setsep[2]{\def\xxxsep{#1 #2 #1}}
\newcommand\setindex[1]{\def\xxxindex{#1}}
\newcommand\setbounds[2]{\def\xxxlower{#1} \def\xxxupper{#2}}
\newcommand\setbrack[2]{\def\xxxleft{#1} \def\xxxright{#2}}

% Print using the overline notation
%\newcommand\ovec[1]{%
%   {\def\subi{_{\xxxindex}}
%    \def\nosubi{{\xxxindex}}
%    \overline{\hbox to 0in{\hss\phantom{M}} #1}^{\xxxindex \in \{ \xxxlower..\xxxupper \}}}}
\newcommand\ovec[1]{%
   {\def\subi{_{\xxxindex}}
    \def\supi{^{\xxxindex}}
    \def\nosubi{{\xxxindex}}
%    \ulcorner #1 \urcorner^{\xxxindex \in \{ \xxxlower..\xxxupper \}}}}
    \left\lceil #1 \right\rceil_{\if \xxxindex \xxxdefaultindex \xxxlower\else \xxxindex = \xxxlower\fi}^{\xxxupper}}}

% This is the comma-separated version
\newcommand\svec[1]{%
   {\xxxleft
    \def\subi{_{\xxxlower}}
    \def\supi{^{\xxxlower}}
    \def\nosubi{{\xxxlower}} #1}
   \xxxsep
   {\def\subi{_{\xxxupper}}
    \def\supi{^{\xxxupper}}
    \def\nosubi{{\xxxupper}}
    #1 \xxxright}}

%
% Shorthand forms
% \mvec means try to use the overline notation
% \cvec means try to use ellipses
%
\newcommand\lvec[3]{\zvector{%
   \setbounds{#2}{#3}
   \ovec{#1}}}

\newcommand\cvec[3]{\zvector{%
   \setbounds{#2}{#3}
   \svec{#1}}}

\newcommand\argvec[3]{\zvector{%
   \setbrack{(}{)}
   \setbounds{#2}{#3}
   \svec{#1}}}

\newcommand\plusvec[3]{\zvector{%
   \setsep{+}{\cdots}
   \setbounds{#2}{#3}
   \svec{#1}}}

\newcommand\rvec[3]{{%
   \setsep{;}{\cdots}
   \cvec{#1}{#2}{#3}}}

\newcommand\vvecdef[4]{\lvec{\vdef{#1}{#2}}{#3}{#4}}
\newcommand\hvecdef[5]{\lvec{\hdef{#1}{#2}{#3}}{#4}{#5}}

%
% Names for defs
%
\newcommand\gvdef{\ms{def}}
\newcommand\gvdefs{\ms{defs}}

\newcommand\skind{\skindname}
\newcommand\kind{\kindname}

\newcommand\Type{\Omega}
\newcommand\Smalltype{\omega}
\newcommand\Recordtype{\mb{record}}

%
% JYH: I'm not positive I like this notation,
% but it seems more intuitive for now that the
% bold notation.
%
\newcommand\Uniontype[1]{\Smalltype_{\ms{union}[#1]}}
\newcommand\Frametype{\Smalltype_\ms{frame}}

\newcommand\Typefun[2]{\Smalltype^{#1} \rightarrow {#2}}

%
% Judgments
% Turn on the shortform to print membership in the short form.
%
\newcommand\eqleft[1]{#1}
\newcommand\eqright[1]{#1}
\newcommand\tyequal[3]{%
   {\def\subeq{\eqleft{_1}}
    \def\supeq{\eqleft{^1}}
    #1}
   =
   {\def\subeq{\eqright{_2}}
    \def\supeq{\eqright{^2}}
    #2}
   : #3}

\newif\ifshortform
\shortformtrue
\newcommand\tymember[2]{%
   \ifshortform
       {\def\subeq{}
        \def\supeq{}
        #1 : #2}
   \else \tyequal{#1}{#1}{#2}
   \fi}

%
% Commands for inference rules
%
\newcommand\genv{\genvname}        % new environment
\newcommand\withenv[2]{#1 \vdash #2}
\newcommand\withgenv[1]{\withenv{\genv}{#1}}
\newcommand\withgenvand[2]{\withenv{\genv, #1}{#2}}

\newcommand\genvtype{\genvtypename}        % new environment
\newcommand\withgenvtype[1]{\withenv{\genvtype}{#1}}
\newcommand\withgenvtypeand[2]{\withenv{\genvtype, #1}{#2}}

%
% Now the rule forms
%
\newcommand\infertwolineleft[2]{{\renewcommand\arraystretch{1}\begin{array}[b]{l} #1\\ #2 \end{array}}}
\newcommand\infertwoline[2]{\infertwolineleft{#1}{\qquad #2}}
\newcommand\infertwocolumn[1]{{\renewcommand\arraystretch{1}\begin{array}[b]{cc} #1 \end{array}}}

\def\minfer[#1]#2#3{\mathright{#1}{\infer{#2}{#3}}}
\def\minferrule#1[#2]#3#4{%
   \gdef#1{\iftechreport \infer{#3}{#4} \else \infer[\hbox{\sc #2}]{#3}{#4} \fi}
   \iftechreport \mathtarget{#2}{\infer{#3}{#4}} \fi}

%
% A strut for forcing arrays to give a better separation
%
\newcommand\rulebox[1]{\rule[-0.1in]{0in}{0.1in} #1}

%
% Helpful inference macros
%
\newcommand\unoptypearg[1]{\mb{arg}(#1)}
\newcommand\unoptyperes[1]{\mb{res}(#1)}
\newcommand\binoptypearg[2]{\mb{arg}_{#1}(#2)}
\newcommand\binoptyperes[1]{\mb{res}(#1)}
\newcommand\indextype{\mb{offset}}
\newcommand\indexatom[2]{\mb{offset}^\mb{const}_{#1}(#2)}

%
% Operational semantics
%
\newcommand\cenv{\cenvname}
\newcommand\checkpoint[3]{\left< #1, #2(\diamond, #3) \right>}
\newcommand\gcstate[3]{\left( #1 \vbar #2 \vbar #3 \right)}
\newcommand\gstate[2]{\gcstate{#1}{\cenv}{#2}}
\newcommand\gerror{\mb{error}}

\newcommand\runtimeload[4]{\mb{runtime}\!\left(#1 \vbar #2[#3] : #4 \right)}
\newcommand\runtimestore[5]{\mb{runtime}\!\left(#1 \vbar #2[#3] : #4 \leftarrow #5 \right)}

%
% Reduction without math mode
%
\newcommand\reducesto[2]{#1 \rightarrow #2}
\newcommand\reduceswhen[3]{{%
   \renewcommand\arraystretch{1}
   \begin{array}[t]{l}
     \reducesto{#1}{#2}\\
     \qquad \mathop{\mb{when}} #3
   \end{array}}}
\newcommand\reduceswhere[3]{{%
  \renewcommand\arraystretch{1}
  \begin{array}[t]{l}
    \reducesto{#1}{#2}\\
    \qquad \mathop{\mb{where}} #3
   \end{array}}}
\newcommand\reducestwoline[2]{{%
  \renewcommand\arraystretch{1}
  \begin{array}[t]{l}
     #1 \rightarrow\\
     \qquad
     #2
   \end{array}}}
\newcommand\reducestwolinewhere[3]{{%
  \renewcommand\arraystretch{1}
  \begin{array}[t]{l}
    #1 \rightarrow\\
    \qquad #2\\
    \qquad \mathop{\mb{where}} #3
  \end{array}}}
\newcommand\reducestwolinewhen[3]{{%
  \renewcommand\arraystretch{1}
  \begin{array}[t]{l}
    #1 \rightarrow\\
    \qquad #2\\
    \qquad \mathop{\mb{when}} #3
  \end{array}}}

%
% Force math mode
%
\newcommand\mreducesto[2]{$$\reducesto{#1}{#2}$$}
\newcommand\mreduceswhere[3]{$$\reduceswhere{#1}{#2}{#3}$$}
\newcommand\mreduceswhen[3]{$$\reduceswhen{#1}{#2}{#3}$$}

\newcommand\mreducestwoline[2]{$$\reducestwoline{#1}{#2}$$}
\newcommand\mreducestwolinewhere[3]{$$\reducestwolinewhere{#1}{#2}{#3}$$}
\newcommand\mreducestwolinewhen[3]{$$\reducestwolinewhen{#1}{#2}{#3}$$}

%
% Rule forms are saved in boxes for leter reference
% and they are also hypertargets.
%
\newcommand\mreducesrule[4]{%
   \newcommand#1{\reducesto{#3}{#4} \iftechreport\else \quad \hbox{\sc #2} \fi}
   \iftechreport \mathtarget{#2}{\reducesto{#3}{#4}} \fi}

\newcommand\mreducestwolinerule[4]{%
   \newcommand#1{\reducestwoline{#3}{#4} \iftechreport\else \quad \hbox{\sc #2} \fi}
   \iftechreport \mathtarget{#2}{\reducestwoline{#3}{#4}} \fi}

\newcommand\mreduceswhererule[5]{%
  \newcommand#1{\reduceswhere{#3}{#4}{#5} \iftechreport\else \quad \hbox{\sc #2} \fi}
  \iftechreport \mathtarget{#2}{\reduceswhere{#3}{#4}{#5}} \fi}

\newcommand\mreduceswhenrule[5]{%
  \newcommand#1{\reduceswhen{#3}{#4}{#5} \iftechreport\else \quad \hbox{\sc #2} \fi}
  \iftechreport \mathtarget{#2}{\reduceswhen{#3}{#4}{#5}} \fi}

\newcommand\mreducestwolinewhererule[5]{%
  \newcommand#1{\reducestwolinewhere{#3}{#4}{#5} \iftechreport\else \quad \hbox{\sc #2} \fi}
  \iftechreport \mathtarget{#2}{\reducestwolinewhere{#3}{#4}{#5}} \fi}

\newcommand\mreducestwolinewhenrule[5]{%
  \newcommand#1{\reducestwolinewhen{#3}{#4}{#5} \iftechreport\else \quad \hbox{\sc #2} \fi}
  \iftechreport \mathtarget{#2}{\reducestwolinewhen{#3}{#4}{#5}} \fi}

%
% Store values
%
\newcommand\storetuple[1]{\xvector{#1}}
\newcommand\storeunion[3]{{#1}_{#2}(#3)}
\newcommand\storefun[2]{\lambda #1 . #2}
\newcommand\storefunpoly[3]{\Lambda #1. \lambda #2 . #3}

\newcommand\xdata{d}
\newcommand\storedata[1]{\left< #1 \right>}
\newcommand\storeframe[3]{\left< #1 : \tyframe{#2}{#3} \right>}

%
% Preservation
%
\newcommand\typeofatom[2]{\ms{typeof}(#1, #2)}

%
% Shorthand
%
\newcommand\metaprl{MetaPRL}
\newcommand\nuprl{NuPRL}
\newcommand\mojave{Mojave}
\newcommand\ensemble{Ensemble}
\newcommand\phobos{Phobos}
\newcommand\ocaml{OCaml}
\newcommand\fir{FIR}

%
% Place a number in a circle
%
\newcommand\numbercircle[1]{%
\begin{picture}(10, 9)
\put(4, 3.5){\circle{9}}
\put(2, 1){\hbox{\scriptsize #1}}
\end{picture}}

%
% Place a picture along the right margin
%
\newdimen\textepsfwidth
\newdimen\textepsfheight
\newcount\textepsflines
\def\rightepsf#1{
    %
    % Get the figure, save its dimensions, and place it
    %
    \setbox3=\hbox{\epsfbox{#1}}
    \textepsfwidth=\wd3
    \textepsfheight=\ht3
    \rightline{\box3}
    \advance\textepsfwidth by 0.25in
    %
    % Go back up
    %
    \vskip-\textepsfheight
    %
    % Now arrange for the text to avoid the figure
    %
    \textepsflines\textepsfheight
    \divide\textepsflines by \baselineskip
    \advance\textepsflines by 1
    \hangindent-\textepsfwidth
    \hangafter-\textepsflines}

\def\rightbox#1{
    %
    % Get the figure, save its dimensions, and place it
    %
    \setbox3=\hbox{#1}
    \textepsfwidth=\wd3
    \textepsfheight=\ht3
    \rightline{\box3}
    \advance\textepsfwidth by 0.25in
    %
    % Go back up
    %
    \vskip-\textepsfheight
    %
    % Now arrange for the text to avoid the figure
    %
    \textepsflines\textepsfheight
    \divide\textepsflines by \baselineskip
    %\advance\textepsflines by 1
    \hangindent-\textepsfwidth
    \hangafter-\textepsflines}

%
% Also need a macro to save the carryover
%
\def\hangcarryover{%
    \edef\next{\hangafter=\the\hangafter
        \hangindent=\the\hangindent}
    \par\next
    \edef\next{\prevgraf=\the\prevgraf}
    \indent\next}



% -*-
% Local Variables:
% Mode: LaTeX
% fill-column: 100
% TeX-master: "paper"
% TeX-command-default: "LaTeX/dvips Interactive"
% End:
% -*-
